<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * if hook execution is enabled this function will be executed
 * when publishing a document, template, object or class
 * The array $param has all information about the respective document.
 *
 * IMPORTANT!
 * Copy this file to the custom/hooks folder when doing any changes
 * Files in the sample_hooks folder are not executed and are not update-safe and will be overwritten by the next webEdition update
 *
 * contents of $param depends on 'from'
 * if from='management' hook is called from object method save,
 * in this case customer is the customer object
 * and type is either 'new' or 'existing'
 * if from='tag', it is called from a we-tag
 * in this case, customer is NOT the customer object but an array,
 * the arraykey is the fieldname, the arrayvalue gives the value
 * the array is passed by reference
 * 'tagname holds the name of the tag ('saveRegisteredUser' or addDelNewsletterEmail)
 * in this case, type is either 'new' or 'modify'
 * for addDelNewsletterEmail additional parameters are isSubscribe' and 'isUnsubscribe'
 */
class we_hook_customer_preSave extends we_hook_base{
	protected $customer; //contains $_SESSION['webuser'] data

	/** @var bool */
	protected $pwdCheck; //!!IMORTANT if this is set to false, password is not compared with the saved password the parameter $_REQUEST['s']['Password'] must still be set, but is ignored

	/** @var string */
	protected $type;

	/** @var string tag,management */
	protected $from;

	/**
	 *
	 * @param we_hook_handler $handler
	 * @param array{customer:array,from:string,type:string} $params
	 */
	public function __construct(we_hook_handler $handler, array $params){
		parent::__construct($handler, $params);
		$this->customer = &$this->param['customer'];
		$this->pwdCheck = $this->param['checkPassword'];
		$this->type = $this->param['type'];
		$this->from = $this->param['from'];
	}

	public function execute(): bool{
		switch($this->type){
			case 'new':
			case 'modify':
		}
		return true;
	}

}
