<?php
declare(strict_types=1);
/**
 * webEdition CMS
 *
 * $Rev: f771893f2c64 $
 * $Author: Lukas Imhof $
 * $Date: 2020-04-17 16:45 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * Class we_button
 *
 * Provides functions for creating webEdition buttons.
 */
class we_html_button{
	//simple button with icon
	private const WE_FA_BUTTON_IDENTIFY = 'fa';
	//button with an icon that is composed of more icons
	private const WE_FASTACK_BUTTON_IDENTIFY = 'fas';
	//button with icon & text
	private const WE_FATEXT_BUTTON_IDENTIFY = 'fat';
	const WE_FORM = 'form';
	private const WE_JS_BUTTON_IDENTIFY = 'javascript';
	public const ADD = 'fa:add,fa-lg fa-plus';
	public const ADD_COLLECTION = 'fa:btn_add_collection,fa-plus,fa-lg fa-archive';
	public const ADD_FIELD = 'fa:btn_add_field,fa-plus,fa-lg fa-square-o';
	public const ADD_FILE = 'fa:btn_add_file,fa-plus,fa-lg fa-file-o';
	public const ADD_IMAGE = 'fa:btn_add_image,fa-upload,fa-lg fa-file-image-o';
	public const ADD_LINK = 'fa:btn_add_link,fa-plus,fa-lg fa-link';
	public const ADD_TO_GLOSSARY = 'to_glossary';
	public const BACK = 'fat:back,fa-lg fa-step-backward';
	//public const CALENDAR = 'fa:date_picker,fa-lg fa-calendar';
	public const CANCEL = 'fat:cancel,fa-lg fa-ban fa-cancel';
	public const CLOSE = 'fat:close,fa-lg fa-close fa-cancel';
	public const DECLINE = 'fat:decline,fa-lg fa-close fa-cancel';
	public const DELETE = 'fa:delete,fa-lg fa-trash-o';
	public const DELETE_ALL = 'fa:delete_all,fa-lg fa-database,fa-lg fa-trash-o';
	public const DELETE_EQUAL = 'fa:delete_equal,fa-lg fa-trash-o, fa-lg fa-exchange';
	public const DIRDOWN = 'fa:btn_direction_down,fa-lg fa-caret-down';
	public const DIRRIGHT = 'fa:btn_direction_right,fa-lg fa-caret-right';
	public const DIRUP = 'fa:btn_direction_up,fa-lg fa-caret-up';
	public const EDIT = 'fa:btn_edit_edit,fa-lg fa-pencil';
	public const OPEN_TO_EDIT = 'fa:btn_edit,fa-lg fa-edit';
	public const EXPORT = 'fat:export,fa-lg fa-download';
	public const FOOTER_COPY = 'fat:btn_function_copy,fa-lg fa-copy';
	public const FOOTER_MAKE_SAME_DOC = 'fas:btn_makeSameDoc,fa-file,fa-lg fa-save fa-inverse';
	public const FOOTER_REBUILD = 'fa:btn_recycle,fa-lg fa-recycle';
	public const FOOTER_SAVE_TO_WORKFLOW = 'fat:in_workflow,fa-lg fa-gears,fa-lg fa-save';
	public const FOOTER_SAVE_VERSION = 'fat:saveversion,fa-lg fa-history,fa-lg fa-save';
	public const FOOTER_PUBLISH = 'fat:publish,fa-lg fa-globe';
	public const FOOTER_UNPUBLISH = 'fat:unpublish,fa-lg fa-moon-o';
	public const FOOTER_SAVE = 'fat:save,fa-lg fa-save';
	public const FOOTER_TRASH = 'fat:btn_function_trash,fa-lg fa-trash-o';
	public const FORWARD = 'fat:forward,fa-lg fa-mail-forward';
	public const IMAGE_SELECT = 'fa:btn_select_image,fa-lg fa-hand-o-right,fa-lg fa-file-image-o';
	public const IMPORT = 'import';
	public const LEVEL_UP = 'fa:btn_fs_back,fa-lg fa-level-up,fa-lg fa-folder';
	public const LINK_EDIT = 'fa:btn_edit_link,fa-lg fa-pencil,fa-lg fa-link';
	public const LIST_ADD = 'fa:btn_add_listelement,fa-plus,fa-lg fa-list-ul';
	public const LOG_CLEAR = 'fat:clear_log,fa-lg fa-book';
	public const LOG_SHOW = 'fat:logbook,fa-lg fa-book';
	public const MAKE_NEW_DOC = 'fas:make_new_document,fa-file,fa-plus fa-inverse';
	public const MAKE_NEW_OBJ = 'fas:make_new_object,fa-file,fa-plus fa-inverse';
	public const MAKE_PREVIEW = 'fa:make_preview,fa-lg fa-refresh, fa-lg fa-eye';
	public const NEW_DIR = 'fa:btn_new_dir,fa-plus,fa-lg fa-folder';
	public const NEW_ENTRY = 'new_entry';
	public const NEXT = 'fat:next,fa-lg fa-step-forward';
	public const NO = 'fat:no,fa-lg fa-close fa-cancel';
	public const OK = 'fat:ok,fa-lg fa-check fa-ok';
	public const OPTIMIZE = 'fa:select,fa-lg fa-wrench,fa-lg fa-thumbs-o-up';
	public const PLUS = 'fa:btn_function_plus,fa-lg fa-plus';
	public const PREVIEW = 'fa:preview,fa-lg fa-eye';
	public const REFRESH = 'fat:refresh,fa-lg fa-refresh';
	public const RELOAD = 'fa:btn_function_reload,fa-lg fa-refresh';
	public const REPLACE = 'fa:replace,fa-search,fa-exchange';
	public const RESET = 'fat:reset,fa-lg fa-eraser';
	public const RESET_VERSION = 'fa:reset,fa-lg fa-history';
	public const ROOT_DIR = 'root_dir';
	public const SAVE = 'fa:save,fa-lg fa-save';
	public const SEARCH = 'fa:btn_function_search,fa-lg fa-search';
	public const SELECT = 'fa:select,fa-lg fa-hand-o-right,fa-lg fa-file-o';
	public const SEND = 'fat:send,fa-lg fa-send-o';
	public const SORT_ASC = 'fa:sortasc,fa-lg fa-sort-alpha-asc';
	public const SORT_DESC = 'fa:sortdesc,fa-lg fa-sort-alpha-desc';
	public const TOGGLE = 'fa:selectAll,fa-lg fa-check-square-o,fa-lg fa-square-o';
	public const TRASH = 'fa:btn_function_trash,fa-lg fa-trash-o';
	public const UNLOCK = 'fa:btn_function_unlock,fa-lg fa-unlock';
	public const UPLOAD = 'fat:upload,fa-lg fa-upload';
	public const VIEW = 'fa:btn_function_view,fa-lg fa-eye';
	public const VIEW_ICON = 'fa:iconview,fa-lg fa-th';
	public const VIEW_LIST = 'fa:listview,fa-lg fa-th-list';
	public const VIEW_FIELDS = 'fa:listview,fa-lg fa-table';
	public const YES = 'fat:yes,fa-lg fa-check fa-ok';

//	const NOT_FOUND = '.fa-lg fa-bullseye';
	/** @var string */
	protected $name;

	/** @var string */
	protected $href = '';

	/** @var string */
	protected $htmlName = '';

	/** @var string */
	protected $on_click = '';

	/** @var bool */
	protected $disabled = false;

	/** @var bool */
	protected $uniqid = true;

	/** @var string */
	protected $suffix = '';

	/** @var bool */
	protected $opensDialog = false;

	/** @var string */
	protected $title = '';

	/** @var string */
	protected $class = '';

	/** @var string */
	protected $id = '';

	/** @var bool */
	protected $notTranslate = false;

	/** @var string */
	protected $value = '';

	public function __construct(string $name, string $href = ''){
		$this->href = $href;
		$this->name = $name;
	}

	public function value(string $name, string $value): self{
		$this->htmlName = $name;
		$this->value = $value;
		return $this;
	}

	public function disable(bool $val): self{
		$this->disabled = $val;
		return $this;
	}

	public function get(): string{
		return self::create_button($this->name, $this->href, $this->htmlName, $this->on_click, $this->disabled, $this->uniqid, $this->suffix, $this->opensDialog, $this->title, $this->class, $this->id, $this->notTranslate, $this->value);
	}

	/**
	 * Gets the HTML Code for the button.
	 * @return string
	 * @param string $id
	 * @param string $cmd
	 * @param string $title
	 * @param boolean $disabled
	 * @static
	 */
	private static function getButton(string $text, string $id, string $cmd, string $title, bool $disabled, bool $isFormButton, string $class, string $htmlName, string $value = ''): string{
		$attribs = [
			'type' => ($isFormButton ? 'submit' : 'button'),
			'title' => $title ? htmlspecialchars($title) : '',
			'disabled' => $disabled,
			'name' => $htmlName,
			'id' => $id,
			'class' => 'weBtn' . ($class ? ' ' . $class : ''),
			'onclick' => htmlspecialchars($cmd),
			'value' => $value
		];
		return we_html_baseElement::getHtmlCode(new we_html_baseElement('button', true, $attribs, $text));
	}

	/**
	 * This functions creates the button.
	 *
	 * @return     string
	 */
	// FIXME: add param display and set class weHide if display===false
	static function create_button(string $name, string $href, string $htmlName = '', string $on_click = '', bool $disabled = false, bool $uniqid = true, string $suffix = '', bool $opensDialog = false, string $title = '', string $class = '', string $id = '', bool $notTranslate = false, string $value = ''): string{

		$all = explode(':', $name, 2);
		list($type, $names) = count($all) == 1 ? ['', ''] : $all;
		// Check if the button is a text button or an image button
		$content = '';
		if($on_click){
			$on_click = ltrim($on_click, ';') . ';';
			if(!$href){
				$href = self::WE_JS_BUTTON_IDENTIFY . ':' . $on_click;
				$on_click = '';
			}
		}
		$hasIcon = false;
		switch($type){
			case self::WE_FASTACK_BUTTON_IDENTIFY://fixme: add stack class
				//get name for title
				list($name, $names) = explode(',', $names, 2);
				$fas = explode(',', $names);
				$content = '<span class="fa-stack">';
				foreach($fas as $cnt => $fa){
					$content .= '<i class="fa ' . ($cnt == 0 ? 'fa-stack-2x ' : 'fa-stack-1x ') . $fa . '"></i>';
				}
				$content .= '</span>';
				$class .= ' weIconButton';
				break;
			case self::WE_FATEXT_BUTTON_IDENTIFY:
				$class .= ' weIconTextButton';
			case self::WE_FA_BUTTON_IDENTIFY:
				$hasIcon = true;
				//get name for title
				list($name, $names) = explode(',', $names, 2);
				$fas = explode(',', $names);
				if(count($fas) > 1){
					$class .= ' multiicon';
				}
				$content = '';
				foreach($fas as $cnt => $fa){
					$content .= (strpos($fa, 'fa-') === false ? $fa : ('<i class="fa ' . ($cnt ? 'fa-moreicon ' : 'fa-firsticon ') . $fa . '"></i>'));
				}
				if($type == self::WE_FA_BUTTON_IDENTIFY){
					$class .= ' weIconButton';
					break;
				}
			//add text, no break;
			default:
				try{
					$text = $notTranslate ? $name : g_l('button', '[' . $name . '][value]', true);
				} catch (we_exception_base $e){
					$text = $notTranslate ? $name : g_l('button', '[' . $name . '][alt]');
				}

				$text .= ($opensDialog ? '&hellip;' : '');
				if($hasIcon){ // we need this, since text is stripped in mobile view
					$content = ($name == 'next' ? '<span class="text">' . $text . ' </span> ' . $content : $content . '<span class="text">' . $text . '</span>');
				} else {
					$content = $text;
				}
		}
		$hrefData = explode(':', $href, 2);
		switch($hrefData[0]){
			case self::WE_FORM:
				$form_name = $hrefData[1];
				$cmd = 'if (document.' . $form_name . '.onsubmit===undefined||document.' . $form_name . '.onsubmit===null||document.' . $form_name . '.onsubmit()) {' . $on_click . ' document.' . $form_name . '.submit(); } return false;';
				break;
			case self::WE_JS_BUTTON_IDENTIFY:
				// Get content of JavaScript
				$cmd = $on_click . $hrefData[1];
				break;
			default:
				// Check if the link has to be opened in a different frame or in a new window
				$cmd = $on_click . ($href ? "window.location.href='" . $href . "';" : ''); /* ); */
		}
		try{
			$alt = $notTranslate ? $name : g_l('button', '[' . $name . '][alt]', true);
		} catch (Exception $e){
			$alt = '';
		}

		return self::getButton($content, ($id ?: ($uniqid ? 'we' . $name . '_' . md5(uniqid(__FUNCTION__, true)) : $name) . $suffix), $cmd, ($title ?: $alt), $disabled, !empty($value) || $hrefData[0] === self::WE_FORM, $class . ' weBtn' . ucfirst($name), $htmlName, $value);
	}

	static function formatButtons(string $buttons): string{
		return '<div style="float:right">' . $buttons . '</div>';
	}

	public static function getButtonIcon(string $icon): string{
		list(, $ret) = explode(',', $icon);
		return $ret;
	}

	/**
	 * This function displays ok, no, cancel - buttons matching to the OS
	 * and places them at the right ($align) side
	 *
	 * For Mac OS         : NO, CANCEL, YES
	 * For Windows & Linux: OK, NO, CANVCEL
	 *
	 * @param      $yes_button                             string
	 * @param      $no_button                              string              (optional)
	 * @param      $cancel_button                          string              (optional)
	 *
	 * @return     string
	 */
	//FIXME: this function is used at many places where yes buttons contains more than one button!!
	static function position_yes_no_cancel(string $yes_button, string $no_button = '', string $cancel_button = ''): string{
		//	button order depends on OS

		return we_html_element::div(['style' => 'padding:0 0 0 0;border-spacing:0;float:right;'], (we_base_browserDetect::isMAC() ?
				$no_button . $cancel_button . $yes_button :
				$yes_button . $no_button . $cancel_button));
	}

}
