<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 5118dfb85839 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-02-13 18:24 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
// file
abstract class we_shop_menu{

	public static function getMenu(): we_gui_menu{

		return new we_gui_menu([
					(new we_gui_menuTop(g_l('modules_shop', '[menu][user]'), 'fa fa-shopping-cart'))
					->set([
						self::getYears(),
						new we_gui_menuSeparator(),
						new we_gui_menuEntry(g_l('modules_shop', '[menu][exit]'), ['exit_shop'])
					]),
					(new we_gui_menuTop(g_l('modules_shop', '[menu][shop_edit]'), 'fa fa-cog', [we_base_perm::SHOP_EDIT_ORDER]))
					->set([
						new we_gui_menuEntry(g_l('modules_shop', '[menu][shop_pref]') . '&hellip;', ['settings'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuSeparator(),
						new we_gui_menuEntry(g_l('modules_shop', '[menu][shop_status]') . '&hellip;', ['edit_shop_status'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuEntry(g_l('modules_shop', '[menu][country_vat]') . '&hellip;', ['edit_shop_vat_country'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuEntry(g_l('modules_shop', '[menu][edit_categories]') . '&hellip;', ['edit_shop_categories'], [we_base_perm::SHOP_EDIT_PREFS], !we_modules_info::isActive(we_modules_info::CATEGORY)),
						new we_gui_menuEntry(g_l('modules_shop', '[menu][edit_vats]') . '&hellip;', ['edit_shop_vats'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuEntry(g_l('modules_shop', '[shipping][shipping_package]') . '&hellip;', ['edit_shop_shipping'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuEntry(g_l('modules_shop', '[shipping][payment_provider]') . '&hellip;', ['payment_val'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuSeparator(),
						new we_gui_menuEntry(g_l('modules_shop', '[shipping][revenue_view]'), ['revenue_view'], [we_base_perm::SHOP_EDIT_PREFS]),
						new we_gui_menuSeparator(),
						(new we_gui_menuSub('order', g_l('modules_shop', '[menu][order]')))
						->set([
							new we_gui_menuEntry(g_l('modules_shop', '[menu][add_article_to_order]'), ['new_article'], [we_base_perm::SHOP_NEW_ARTICLE]),
							new we_gui_menuEntry(g_l('modules_shop', '[menu][delete_order]'), ['delete_shop'], [we_base_perm::SHOP_DELETE_ARTICLE]),
						])
					])
		]);
	}

	private static function getYears(): we_gui_menuSub{
		$years = we_shop_shop::getAllOrderYears();
		$sub = new we_gui_menuSub('jahr', g_l('modules_shop', '[menu][year]'));

		foreach($years as $cur){
			$sub->append(new we_gui_menuEntry((string) $cur, ['year', $cur]));
		}
		return $sub;
	}

}
