<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_addDelShopItem extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		if(!we_modules_info::isActive(we_modules_info::SHOP)){
			echo self::modulMissingError('Shop', __CLASS__);
			return '';
		}
		if(($foo = self::attributeMissing($attribs, ['shopname' => false], __CLASS__))){
			return $foo;
		}

		$shopname = self::getAttribute('shopname', $attribs, '', we_base_request::STRING);
		$floatquantities = self::getAttribute('floatquantities', $attribs, false, we_base_request::BOOL);

		we_modules_info::isActive(we_modules_info::SHOP);

		$rShopname = we_base_request::string('shopname');
		if($rShopname && $rShopname !== $shopname){
			return '';
		}

		$basket = we_tag_createShop::getBasket($shopname);
		if(is_array(($cartIDs = we_base_request::_(we_base_request::STRING, 'shop_cart_id')))){
			if(we_base_request::int('t', 0) > ($_SESSION['tb'] ?? 0 )){
				foreach($cartIDs as $cartId => $cartAmount){
					$basket->setCartItem(strip_tags($cartId), $floatquantities ? we_base_util::std_numberformat((string) $cartAmount) : intval($cartAmount));
				}
				$_SESSION[$shopname . '_save'] = $basket->getCartProperties();
			}
			//FIXME: change to INT/FLOAT
		} else if(is_array($shopAnzahl = we_base_request::_(we_base_request::STRING, 'shop_anzahl_und_id'))){
			if(we_base_request::int('t', 0) > (empty($_SESSION['tb']) ? 0 : $_SESSION['tb'] )){
				foreach($shopAnzahl as $shop_articleid_variant => $anzahl){
					$articleInfo = explode('_', strip_tags($shop_articleid_variant));
					$basket->setItem(intval($articleInfo[0]), ($floatquantities ? we_base_util::std_numberformat((string) $anzahl) : intval($anzahl)), $articleInfo[1], ($articleInfo[2] ?? ''));
					unset($articleInfo);
				}
				$_SESSION[$shopname . '_save'] = $basket->getCartProperties();
				$_SESSION['tb'] = we_base_request::int('t', 0);
			}
		} else if(($artID = we_base_request::int('shop_artikelid')) && ($shopAnz = we_base_request::_($floatquantities ? we_base_request::FLOAT : we_base_request::INT, 'shop_anzahl'))){
			if(we_base_request::int('t', 0) > (empty($_SESSION['tb']) ? 0 : $_SESSION['tb'] )){
				$basket->addItem($artID, $shopAnz, we_base_request::string('type'), we_base_request::string(we_base_variants::REQUEST), we_base_request::stringList(we_shop_shop::ARTICLE_CUSTOM_FIELD));
				$_SESSION[$shopname . '_save'] = $basket->getCartProperties();
				$_SESSION['tb'] = we_base_request::int('t');
			}
		} else if(($artID = we_base_request::int('del_shop_artikelid'))){
			if(we_base_request::int('t', 0) > ($_SESSION['tb'] ?? 0 )){
				$basket->delItem($artID, we_base_request::string('type'), (we_base_request::string(we_base_variants::REQUEST)), we_base_request::stringList(we_shop_shop::ARTICLE_CUSTOM_FIELD));
				$_SESSION[$shopname . '_save'] = $basket->getCartProperties();
				$_SESSION['tb'] = we_base_request::int('t');
			}
		}

		return '';
	}

}
