<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 6be592b6a6b2 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-01-03 01:14 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_docType extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		self::$doc = we_base_WE::getWeDoc();

		switch(self::getAttribute('doc', $attribs, '', we_base_request::STRING)){
			case 'self':
				return empty(self::$doc->DocType) ? '' : fS('SELECT Text FROM ' . DOC_TYPES_TABLE . ' WHERE ID=' . DB_WE::$inst->escape(self::$doc->DocType));

			case 'top':
			default:
				if(we_base_WE::$mainDoc['doc']){
					return empty(we_base_WE::$mainDoc['doc']->DocType) ? '' : fS('SELECT Text FROM ' . DOC_TYPES_TABLE . ' WHERE ID=' . DB_WE::$inst->escape(we_base_WE::$mainDoc['doc']->DocType));
				}
				return empty(self::$doc->DocType) ? '' : fS('SELECT Text FROM ' . DOC_TYPES_TABLE . ' WHERE ID=' . DB_WE::$inst->escape(self::$doc->DocType));
		}
	}

}
