<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifCat extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		$categories = self::getAttribute('categories', $attribs, self::getAttribute('category', $attribs, [], we_base_request::STRING_LIST, true), we_base_request::STRING_LIST);
		$catids = self::getAttribute('categoryids', $attribs, [], we_base_request::INTLISTA);
		if(!$categories && !$catids){
			if(($foo = self::attributeMissing($attribs, ['categories' => false], __CLASS__))){
				echo $foo;
				return false;
			}
		}

		$parent = self::getAttribute('parent', $attribs, false, we_base_request::BOOL);
		$docAttr = self::getAttribute('doc', $attribs, 'self', we_base_request::STRING);

		switch($docAttr){
			case 'listview':
				$cat = (empty(we_tag_listview::$current) ? [] : we_base_request::filterIntList(we_tag_listview::$current->f(we_listview_base::CATEGORY_FIELD)));
				break;
			default:
				$doc = self::getDocForTag($docAttr);
				$cat = $doc->Category;
				'@phan-var int[] $cat';
		}

		if($catids){
			if($parent){
				$categories = id2pathA($catids, CATEGORY_TABLE);
			} else {
				//no need to query db
				$cat = array_filter(array_map('intval', $cat));
				return (array_intersect($cat, array_filter($catids)) ? true : false);
			}
		}

		$DocCatsPaths = id2pathA($cat, CATEGORY_TABLE);
		$DocCatsPathsStr = implode(',', $DocCatsPaths);

		foreach($categories as $match){
			$match = '/' . trim((string) $match, '/');
			if(in_array($match, $DocCatsPaths)){
				return true;
			}
			if($parent && strpos($DocCatsPathsStr, $match . '/') !== false){
				return true;
			}
		}
		return false;
	}

}
