<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifEqual extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		if((self::attributeMissing($attribs, ['name' => false], __CLASS__))){
			return false;
		}
		self::$doc = we_base_WE::getWeDoc();

		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$eqname = self::getAttribute('eqname', $attribs, '', we_base_request::STRING);
		$value = self::getAttribute('value', $attribs, '', we_base_request::RAW);

		$elemValue = we_tag_var::getElementData(self::$doc, $name);
		if(!$eqname){
			if((self::attributeMissing($attribs, ['value' => false], __CLASS__))){
				return false;
			}

			return ($elemValue == $value);
		}

		if(($foo = self::attributeMissing($attribs, ['eqname' => false], __CLASS__))){
			echo $foo;
			return false;
		}
		$blockeq = self::getPostName($eqname);

		if(we_base_WE::$mainDoc['doc']->issetElement($blockeq)){//check if eqname is present in block
			$blockeqVal = we_tag_var::getElementData(self::$doc, $blockeq);
			return ($elemValue == $blockeqVal);
		}
		if(we_base_WE::$mainDoc['doc']->issetElement($eqname)){//check if eqname is present in document
			$eqVal = we_tag_var::getElementData(self::$doc, $eqname);
			return ($elemValue == $eqVal);
		}
//check if eqname is present in GLOBALS
		return (isset($GLOBALS[$eqname])) && ($GLOBALS[$eqname] == $elemValue);
	}

}
