<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifIsDomain extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		if(($foo = self::attributeMissing($attribs, ['domain' => false], __CLASS__))){
			echo $foo;
			return false;
		}
		if(we_base_WE::$editmode){
			return true;
		}

		$domain = explode(',', strtolower(self::getAttribute('domain', $attribs, '', we_base_request::STRING)));
		$matchType = self::getAttribute('matchType', $attribs, 'exact', we_base_request::STRING);
		$servername = strtolower($_SERVER['SERVER_NAME']);
		switch($matchType){
			case 'exact':
				return in_array($servername, $domain, true);
			case 'contains':
				foreach($domain as $d){
					if(strpos($servername, $d) !== false){
						return true;
					}
				}
				return false;
			case 'front':
				foreach($domain as $d){
					if(strpos($servername, $d) === 0){
						return true;
					}
				}
				return false;
			case 'back':
				$len = strlen($servername);
				foreach($domain as $d){
					$pos = strpos($servername, $d);
					if($pos !== false && ($pos + strlen($d)) === $len){
						return true;
					}
				}
				return false;
			default:
				return false;
		}
	}

}
