<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d5bcf73330c9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-28 19:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifShopField extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		if(($foo = self::attributeMissing($attribs, ['name' => false, 'reference' => false, 'shopname' => false, 'match' => true], __CLASS__))){
			echo $foo;
			return false;
		}
		$match = self::getAttribute('match', $attribs, '', we_base_request::STRING);
		$operator = self::getAttribute('operator', $attribs, '', we_base_request::RAW);

		$atts = self::removeAttribs($attribs, ['match', 'operator']);
		$atts['type'] = 'print';
		$realvalue = (string) we_weTag_util::tag('shopField', $atts);

		switch($operator){
			default:
			case 'equal':
				return $realvalue === $match;
			case 'less':
				return intval($realvalue) < intval($match);
			case 'less|equal':
				return intval($realvalue) <= intval($match);
			case 'greater':
				return intval($realvalue) > intval($match);
			case 'greater|equal':
				return intval($realvalue) >= intval($match);
			case 'contains':
				return (strpos($realvalue, $match) !== false); //@phan-suppress-current-line PhanPluginSuspiciousParamOrderInternal
		}
	}

}
