<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifUserInputEmpty extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		if(($foo = self::attributeMissing($attribs, ['match' => false], __CLASS__))){
			echo $foo;
			return false;
		}
		return !self::we_isUserInputNotEmpty($attribs);
	}

	protected static function we_isUserInputNotEmpty(array $attribs): bool{
		$formname = self::getAttribute('formname', $attribs, we_base_constants::DEFAULT_FORM, we_base_request::STRING);
		$match = self::getAttribute('match', $attribs, '', we_base_request::STRING);
		$var = we_base_request::_(we_base_request::HTML, 'we_ui_' . $formname, '', $match);
		return (!empty($var));
	}

}
