<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f389fd111aab $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-17 01:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_metadata extends we_weTag_tag{

	public static function parse(array $attribs, string $content): string{
		if(($foo = self::attributeMissing($attribs,[ 'name'=>false,'id'=>false], __CLASS__))){
			return $foo;
		}
		return '<?php if(' . we_weTag_parser::printTag('metadata', $attribs) . '){?>' . $content . '<?php } we_tag_listview::post();?>';
	}

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$id = self::getAttribute('id', $attribs, 0, we_base_request::INT);
		self::$doc = we_base_WE::getWeDoc();

		$unique = md5(uniqid(__FILE__, true));
		if(!$id && $name){
			$value = (we_tag_listview::$current ?
				we_tag_listview::$current->f($name) :
				// determine the id of the element
				(self::$doc->getElementI($name) ?:
				//can be href
				self::$doc->getElementI($name . we_base_link::MAGIC_INT_LINK_ID)
				)
				);

			// it is an id
			$id = (int) (is_numeric($value) ? $value : 0);
		}

		if($id){
			$lv = new we_listview_document($unique, 1, 0, '', false, '', [], false, false, [], '', 0, false, '', '', '', '', '', [], 'off', true, [], [$id], [], false, false, 0);
			we_tag_listview::pre($lv);
			return $lv->next_record();
		}
		//we need this to keep the stack synchronized
		we_tag_listview::pre(new we_listview_pseudo());
		return false;
	}

}
