<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 893373785c25 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-06-04 18:23 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_navigationEntry extends we_weTag_tag{

	public static function parse(array $attribs, string $content): string{
		if(($foo = self::attributeMissing($attribs, ['type' => false], __CLASS__))){
			return $foo;
		}

		return '<?php ' . we_weTag_parser::printTag('navigationEntry', $attribs, strtr($content, ['global $lv;' => '', '\\\\$' => '']), true) . ';?>';
	}

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): void{
		if(($foo = self::attributeMissing($attribs, ['type' => false], __CLASS__))){
			echo $foo;
			return;
		}

		$navigationName = self::getAttribute('navigationname', $attribs, 'default', we_base_request::STRING);
		$type = self::getAttribute('type', $attribs, '', we_base_request::STRING);
		$level = self::getAttribute('level', $attribs, we_navigation_items::TEMPLATE_DEFAULT_LEVEL, we_base_request::STRING);
		$current = (isset($attribs['current']) ?
			(self::getAttribute('current', $attribs, false, we_base_request::BOOL) ? '1' : '0') :
			we_navigation_items::TEMPLATE_DEFAULT_CURRENT);

		$positions = self::getAttribute('position', $attribs, [we_navigation_items::TEMPLATE_DEFAULT_POSITION], we_base_request::STRING_LIST);
		$items = we_tag_navigation::getNaviItem($navigationName);
		if(!$items){
			echo self::parseError('we:navigationentry "' . $navigationName . '" not set', __CLASS__);
			return;
		}

		foreach($positions as $position){
			$items->setTemplate(str_replace('\$', '$', $content), $type, $level, $current, $position);
		}
	}

}
