<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_author extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::USERS;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);
		$this->Attributes = [
			new we_weTag_selectAttribute('type', [
				new we_weTag_option('username'),
				new we_weTag_option('forename'),
				new we_weTag_option('surname'),
				new we_weTag_option('name'),
				new we_weTag_option('initials'),
				new we_weTag_option('salutation'),
				new we_weTag_option('email'),
				new we_weTag_option('address'),
				new we_weTag_option('zip'),
				new we_weTag_option('city'),
				new we_weTag_option('state'),
				new we_weTag_option('country'),
				new we_weTag_option('telephone'),
				new we_weTag_option('fax'),
				new we_weTag_option('mobile'),
				new we_weTag_option('description'),
				new we_weTag_option('company'),
				new we_weTag_option('department'),
				], false, ''),
			new we_weTag_selectAttribute('doc', [
				new we_weTag_option('self'),
				new we_weTag_option('top'),
				new we_weTag_option('listview'),
				], false, ''),
			new we_weTag_selectAttribute('creator', we_weTag_selectAttribute::getTrueFalse())
		];
	}

}
