<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: d24ecdc64229 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-02 16:29 +0100 $
 */
class we_tw_ifPageLanguage extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);
		$locales = [];
		foreach(we_base_WE::$Langs['FrontendLanguages'] as $lv){
			$locales[] = new we_weTag_option($lv);
		}

		$this->Attributes = [
			new we_weTag_choiceAttribute('match', $locales, false, true, ''),
			new we_weTag_selectAttribute('doc', [new we_weTag_option('top'),
				new we_weTag_option('self'),
				], false),
		];
	}

}
