<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_select extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_INPUT];
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);
		$this->DefaultValue = '<option>#1</option>
<option>#2</option>
<option>#3</option>';

		$name = new we_weTag_textAttribute('name', true, '');
		$size = new we_weTag_textAttribute('size', false, '');
		$reload = new we_weTag_selectAttribute('reload', we_weTag_selectAttribute::getTrueFalse());
		$values = new we_weTag_textAttribute('values', false, '');
		$multiple = new we_weTag_selectAttribute('multiple', we_weTag_selectAttribute::getTrueFalse(true));

		$this->TypeAttribute = new we_weTag_typeAttribute('type', [
			new we_weTag_option('', false, '', [$name, $size, $reload]),
			new we_weTag_option('html', false, '', [$name, $size, $reload]),
			new we_weTag_option('csv', false, '', [$name, $size, $reload, $values])]);

		$this->Attributes = [$name, $size, $reload, $values, $multiple];
	}

}
