<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: a4ea05d4f4ee $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-03 23:20 +0100 $
 */
class we_tw_sendMail extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = false;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$this->Attributes = [
			new we_weTag_textAttribute('attachments', false, ''),
			new we_weTag_selectorAttribute('attachmentIDs', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT),
			new we_weTag_textAttribute('id', false, ''),
			new we_weTag_textAttribute('subject', false, ''),
			new we_weTag_textAttribute('recipient', true, ''),
			new we_weTag_textAttribute('recipientCC', false, ''),
			new we_weTag_textAttribute('recipientBCC', false, ''),
			new we_weTag_textAttribute('from', true, ''),
			new we_weTag_textAttribute('reply', false, ''),
			new we_weTag_selectAttribute('mimetype', [
				new we_weTag_option(we_mail_mime::TYPE_TEXT),
				new we_weTag_option(we_mail_mime::TYPE_HTML),
				], false, ''),
			new we_weTag_textAttribute('charset', false, ''),
			new we_weTag_selectAttribute('includeimages', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectAttribute('usebasehref', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectAttribute('useformmailLog', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectAttribute('useformmailBlock', we_weTag_selectAttribute::getTrueFalse()),
		];
	}

}
