<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e2c462077a60 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-02-25 19:07 +0100 $
 */
class we_tw_write extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = false;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$formname = new we_weTag_textAttribute('formname', false, '');
		$publish = new we_weTag_selectAttribute('publish', we_weTag_selectAttribute::getTrueFalse());
		$searchable = new we_weTag_selectAttribute('searchable', we_weTag_selectAttribute::getTrueFalse());

		$doctype = new we_weTag_sqlRowAttribute('Text', DOC_TYPES_TABLE, true, 'Text');
		$tid = new we_weTag_selectorAttribute('tid', TEMPLATES_TABLE, we_base_ContentTypes::TEMPLATE, false, '');
		$categories = new we_weTag_multiSelectorAttribute('categories', CATEGORY_TABLE, '', 'Path', false, we_modules_info::CATEGORY);
		$classid = new we_weTag_selectorAttribute('classid', OBJECT_TABLE, we_base_ContentTypes::OBJECT, false, we_modules_info::OBJECT);
		$protected = new we_weTag_selectAttribute('protected', we_weTag_selectAttribute::getTrueFalse(), false, we_modules_info::CUSTOMER);
		$admin = new we_weTag_textAttribute('admin', false, '');
		$forceedit = new we_weTag_selectAttribute('forceedit', we_weTag_selectAttribute::getTrueFalse());
		$mail = new we_weTag_textAttribute('mail', false, '');
		$mailfrom = new we_weTag_textAttribute('mailfrom', false, '');
		$triggerid = new we_weTag_selectorAttribute('triggerid', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT, false, '');
		$workspaces = new we_weTag_textAttribute('workspaces', false, '');
		$parentid = new we_weTag_selectorAttribute('parentid', OBJECT_FILES_TABLE, we_weTag_selectorAttribute::FOLDER, false, we_modules_info::OBJECT);
		$userid = new we_weTag_textAttribute('userid', false, '');
		$name = new we_weTag_textAttribute('name', false, '');
		$onduplicate = new we_weTag_selectAttribute('onduplicate', [
			new we_weTag_option('abort'),
			new we_weTag_option('overwrite'),
			new we_weTag_option('increment'),
			], false, '');
		$onpredefinedname = new we_weTag_selectAttribute('onpredefinedname', [
			new we_weTag_option('appendto'),
			new we_weTag_option('infrontof'),
			new we_weTag_option('overwrite'),
			], false, '');
		$workflowname = new we_weTag_textAttribute('workflowname', false, '');
		$workflowuserid = new we_weTag_textAttribute('workflowuserid', false, '');

		$locales = [
			new we_weTag_option('self'),
			new we_weTag_option('top')
		];
		$language = new we_weTag_choiceAttribute('language', $locales, false, true, '');

		$this->TypeAttribute = new we_weTag_typeAttribute('type', [new we_weTag_option('document', false, '', [$formname, $publish, $searchable, $language, $doctype,
				$tid, $categories, $userid, $admin, $forceedit, $mail, $mailfrom, $protected, $workflowname, $workflowuserid], [$doctype]),
			new we_weTag_option('object', false, '', [$formname, $publish, $searchable, $language, $categories, $classid, $name, $onduplicate, $onpredefinedname, $userid,
				$admin, $forceedit, $mail, $mailfrom, $triggerid, $parentid, $protected, $workflowname, $workflowuserid], [$classid])], false, '');

		$this->Attributes = [$formname, $publish, $searchable, $language, $doctype, $tid, $categories, $classid, $protected, $admin, $forceedit, $mail, $mailfrom,
			$triggerid,
			$workspaces, $parentid, $userid, $name, $onduplicate, $onpredefinedname, $workflowname, $workflowuserid];
	}

}
