<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 9dcb937660e9 $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-09-05 21:29 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_xml_composer{

	static function we_xmlElement(string $name, string $content = '', array $attributes = []): string{
		$element = new we_html_baseElement($name, true, $attributes, $content);
		return $element->getHTML();
	}

	/* Function creates new xml element.
	 *
	 * element - [name] - element name
	 * 				 [attributes] - atributes array in form arry['attribute_name']=attribute_value
	 * 				 [content] - if array childs otherwise some content
	 *
	 */

	/* static function buildXMLElements(array $elements){
	  $out = '';
	  foreach($elements as $element){
	  $element = new we_html_baseElement($element['name'], true, $element['attributes'], (is_array($element['content']) ? self::buildXMLElements($element['content']) : $element['content']));
	  $out .= $element->getHTML();
	  }
	  return $out;
	  }
	 */

	static function buildAttributesFromArray(array $attribs): string{
		$out = '';
		foreach($attribs as $k => $v){
			if($v == null && $v){
				$out .= ' ' . $k;
			} else {
				$out .= ' ' . $k . '="' . $v . '"';
			}
		}

		return $out;
	}

}
