/* global WE, top, entries */

/**
 * webEdition CMS
 *
 * $Author: Lukas Imhof $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

function doClick(id, ct) {
	if (WE().util.dialogTop(window).document.getElementById('fspreviewDiv')) {
		WE().util.dialogTop(window).document.getElementById('fspreviewDiv').innerHTML = "";
	}
	if (ct == 1) {
		if (WE().util.dialogTop(window).metaKeys.doubleClick) {
			setDir(id);
			window.setTimeout(function () {
				WE().util.dialogTop(window).metaKeys.doubleClick = false;
			}, 400);
		}
	} else if ([WE().consts.contentTypes.FOLDER_COMMON, WE().consts.contentTypes.FOLDER_DOCUMENT, WE().consts.contentTypes.FOLDER_TEMPLATE, WE().consts.contentTypes.FOLDER_OBJECTFILE,
		WE().consts.contentTypes.FOLDER_VFILE].indexOf(WE().util.dialogTop(window).getEntry(id).contentType) === -1 || (WE().util.dialogTop(window).fileSelect.options.canSelectDir)) {
		if (WE().util.dialogTop(window).fileSelect.options.multiple) {
			if (WE().util.dialogTop(window).metaKeys.shift) {
				var oldid = WE().util.dialogTop(window).fileSelect.data.currentID;
				var currendPos = WE().util.dialogTop(window).getPositionByID(id);
				var firstSelected = WE().util.dialogTop(window).getFirstSelected();

				if (currendPos > firstSelected) {
					WE().util.dialogTop(window).selectFilesFrom(firstSelected, currendPos);
				} else if (currendPos < firstSelected) {
					WE().util.dialogTop(window).selectFilesFrom(currendPos, firstSelected);
				} else {
					WE().util.dialogTop(window).selectFile(id);
				}
				WE().util.dialogTop(window).fileSelect.data.currentID = oldid;

			} else if (!WE().util.dialogTop(window).metaKeys.ctrl) {
				WE().util.dialogTop(window).selectFile(id);
			} else if (WE().util.dialogTop(window).isFileSelected(id)) {
				WE().util.dialogTop(window).unselectFile(id);
			} else {
				WE().util.dialogTop(window).selectFile(id);
			}
		} else {
			WE().util.dialogTop(window).selectFile(id);
		}
	} else {
		showPreview(id);

	}
	if (WE().util.dialogTop(window).metaKeys.ctrl) {
		WE().util.dialogTop(window).metaKeys.ctrl = 0;
	}
	if (WE().util.dialogTop(window).metaKeys.shift) {
		WE().util.dialogTop(window).metaKeys.shift = 0;
	}
}

function setDir(id) {
	if (WE().util.dialogTop(window).document.getElementById('fspreviewDiv')) {
		WE().util.dialogTop(window).document.getElementById('fspreviewDiv').innerHTML = "";
	}
	showPreview(id);
	WE().util.dialogTop(window).fscmd.location.replace(WE().util.dialogTop(window).queryString(WE().consts.selectors.SETDIR, id));
	var e = WE().util.dialogTop(window).getEntry(id);
	WE().util.dialogTop(window).document.getElementById('fspath').innerHTML = e.path;
}

function selectFile(id) {
	var a = WE().util.dialogTop(window).document.getElementsByName("fname")[0];
	if (id) {
		var e = WE().util.dialogTop(window).getEntry(id);
		WE().util.dialogTop(window).document.getElementById('fspath').innerHTML = e.path;
		if (a.value != e.text &&
			a.value.indexOf(e.text + ",") === -1 &&
			a.value.indexOf("," + e.text + ",") === -1 &&
			a.value.indexOf("," + e.text + ",") === -1) {
			a.value = a.value ?
				(a.value + "," + e.text) :
				e.text;
		}

		if (WE().util.dialogTop(window).fsbody.document.getElementById("line_" + id)) {
			WE().util.dialogTop(window).fsbody.document.getElementById("line_" + id).classList.add("selected");
		}
		WE().util.dialogTop(window).fileSelect.data.currentPath = e.path;
		WE().util.dialogTop(window).fileSelect.data.currentID = id;
		WE().util.dialogTop(window).fileSelect.data.we_editDirID = 0;
		WE().util.dialogTop(window).fileSelect.data.currentType = e.contentType;
		WE().util.dialogTop(window).fileSelect.data.currentTable = WE().util.dialogTop(window).fileSelect.options.table;
		showPreview(id);
	} else {
		a.value = "";
		WE().util.dialogTop(window).fileSelect.data.currentType = "";
		WE().util.dialogTop(window).fileSelect.data.currentPath = "";
		WE().util.dialogTop(window).fileSelect.data.we_editDirID = 0;
	}
}

function addEntry(ID, text, extension, isFolder, path, modDate, contentType, published, title) {
	entries.push({
		ID: ID,
		text: text,
		isFolder: isFolder,
		path: path,
		modDate: modDate,
		contentType: contentType,
		extension: extension,
		published: published,
		title: title
	});
}

function setFilter(ct) {
	WE().util.dialogTop(window).fscmd.location.replace(WE().util.dialogTop(window).queryString(WE().consts.selectors.CMD, WE().util.dialogTop(window).fileSelect.data.currentDir, "", "", ct));
}

function reloadDir() {
	WE().util.dialogTop(window).fscmd.location.replace(WE().util.dialogTop(window).queryString(WE().consts.selectors.CMD, WE().util.dialogTop(window).fileSelect.data.currentDir));
}

function newFile() {
	var url = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_fileupload_editor&we_cmd[import]=1&we_cmd[parentid]=" + WE().util.dialogTop(window).fileSelect.data.currentDir + "&we_cmd[fixed]=1&we_cmd[writeback]=selector_insertFromUploader";
	(new (WE().util.jsOverlay)(window, 'top',url, 'we_fileupload_editor', WE().consts.size.dialog.small, WE().consts.size.dialog.big)).setResizeable().open();
}

function newCollection() {
	var url = "we_cmd.php?we_cmd[0]=editNewCollection&we_cmd[1]=write_back_to_selector&fixedpid=" + WE().util.dialogTop(window).currentDir;
	(new (WE().util.jsOverlay)(window, 'top',url, 'edit_new_collection', WE().consts.size.dialog.small, WE().consts.size.dialog.small)).setResizeable().open();
}

function writeBodyDocument(d) {
	var body = (WE().util.dialogTop(window).fileSelect.data.makeNewFolder ?
		'<tr class="newEntry">' +
		'<td class="selectoricon">' + WE().util.getTreeIcon(WE().consts.contentTypes.FOLDER_COMMON, false) + '</td>' +
		'<td class="filename"><input type="hidden" name="we_FolderText" value="' + WE().consts.g_l.fileselector.new_folder_name + '" /><input onmousedown="WE().util.dialogTop(window).metaKeys.inputClick=true" name="we_FolderText_tmp" type="text" value="' + WE().consts.g_l.fileselector.new_folder_name + '" class="wetextinput" /></td>' +
		'<td class="selector title">' + WE().consts.g_l.fileselector.folder + '</td>' +
		'<td class="selector moddate">' + WE().consts.g_l.fileselector.date_format + '</td>' +
		'<th class="selector remain"></th></tr>' :
		'');
	for (var i = 0; i < entries.length; i++) {
		body += '<tr id="line_' + entries[i].ID + '" class="' + ((entries[i].ID == WE().util.dialogTop(window).fileSelect.data.currentID) ? 'selected' : '') + '" ' + ((WE().util.dialogTop(window).fileSelect.data.we_editDirID || WE().util.dialogTop(window).fileSelect.data.makeNewFolder) ? '' : ' onclick="return selectorOnClick(event,' + entries[i].ID + ');"') + (entries[i].isFolder ? ' ondblclick="return selectorOnDblClick(' + entries[i].ID + ');"' : '') + '>' +
			'<td class="selector selectoricon">' + WE().util.getTreeIcon(entries[i].contentType, false) + '</td>' +
			'<td class="selector filename"' + (entries[i].published === 0 && entries[i].isFolder === 0 ? ' style="color: red;"' : "") + ' title="' + entries[i].text + '">' +
			(WE().util.dialogTop(window).fileSelect.data.we_editDirID == entries[i].ID ?
				'<input type="hidden" name="we_FolderText" value="' + entries[i].text + '" /><input onmousedown="WE().util.dialogTop(window).metaKeys.inputClick=true" name="we_FolderText_tmp" type="text" value="' + entries[i].text + '" class="wetextinput" style="width:100%" />' :
				'<div style="width:100%"><div class="cutText">' + entries[i].text + '</div><div class="cutText extension">' + entries[i].extension + '</div></div>'
				) +
			'</td>' +
			'<td class="selector title" title="' + (WE().util.dialogTop(window).fileSelect.options.useID ? entries[i].ID : entries[i].title) + '"><div class="cutText">' + (WE().util.dialogTop(window).fileSelect.options.useID ? entries[i].ID : entries[i].title) + '</div></td>' +
			'<td class="selector moddate">' + entries[i].modDate + '</td>' +
			'<td class="remain"></td></tr>';
	}
	d.innerHTML = '<form name="we_form" target="fscmd" method="post" action="' + WE().util.dialogTop(window).fileSelect.options.formtarget + '" onsubmit="document.we_form.we_FolderText.value=document.we_form.we_FolderText_tmp.value;return true;">' +
		(WE().util.dialogTop(window).fileSelect.data.we_editDirID ?
			'<input type="hidden" name="what" value="' + WE().consts.selectors.DORENAMEFOLDER + '" />' +
			'<input type="hidden" name="we_editDirID" value="' + WE().util.dialogTop(window).fileSelect.data.we_editDirID + '" />' :
			'<input type="hidden" name="what" value="' + WE().consts.selectors.CREATEFOLDER + '" />'
			) +
		'<input type="hidden" name="order" value="' + WE().util.dialogTop(window).fileSelect.data.order + '" />' +
		'<input type="hidden" name="rootDirID" value="' + WE().util.dialogTop(window).fileSelect.options.rootDirID + '" />' +
		'<input type="hidden" name="table" value="' + WE().util.dialogTop(window).fileSelect.options.table + '" />' +
		'<input type="hidden" name="id" value="' + WE().util.dialogTop(window).fileSelect.data.currentDir + '" />' +
		'<table class="selector sort"><thead><tr>' + WE().util.dialogTop(window).fileSelect.options.selectorHeader + '</tr></thead><tbody>' +
		body + '</tbody></table></form>';
	if (WE().util.dialogTop(window).fileSelect.data.makeNewFolder || WE().util.dialogTop(window).fileSelect.data.we_editDirID) {
		WE().util.dialogTop(window).fsbody.document.we_form.we_FolderText_tmp.focus();
		WE().util.dialogTop(window).fsbody.document.we_form.we_FolderText_tmp.select();
	}
	window.fsbody.$('table.sort').tablesorter();
}

function writeBody(d) {
	writeBodyDocument(d);
}

function queryString(what, id, o, we_editDirID, filter) {
	if (!o) {
		o = WE().util.dialogTop(window).fileSelect.data.order;
	}
	if (!filter) {
		filter = WE().util.dialogTop(window).fileSelect.data.currentType;
	}
	return WE().util.dialogTop(window).fileSelect.options.formtarget +
		'&we_cmd[what]=' + what +
		'&we_cmd[rootDirID]=' + WE().util.dialogTop(window).fileSelect.options.rootDirID +
		'&we_cmd[open_doc]=' + WE().util.dialogTop(window).fileSelect.options.open_doc +
		'&we_cmd[table]=' + WE().util.dialogTop(window).fileSelect.options.table +
		'&we_cmd[id]=' + id +
		(o ? ("&we_cmd[order]=" + o) : "") +
		(we_editDirID ? ("&we_cmd[we_editDirID]=" + we_editDirID) : "") +
		(filter ? ("&we_cmd[filter]=" + filter) : "");
}
