/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/* global WE, top */
'use strict';

var activ_tab = 0;
var hot = false;
var scrollToVal = 0;

WE().util.loadConsts(document, "g_l.customer");


var aTabs = WE().util.getDynamicVar(document, 'loadVarCustomerHeader', 'data-customerHeader');

function setTab(tab) {
	top.content.activ_tab = tab;
	window.parent.edbody.we_cmd("switchPage", tab);
}

function loaded() {
	window.weTabs.setFrameSize();
	if (top.content.activ_tab) {
		document.getElementById(aTabs[top.content.activ_tab]).className = "tabActive";
	} else {
		document.getElementById("common").className = "tabActive";
	}
}

function setHot() {
	hot = true;
}

function unsetHot() {
	hot = false;
}

function doUnload() {
	WE().util.jsWindow.prototype.closeAll(window);
}

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window),
		args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments)),
		url = WE().util.getWe_cmdArgsUrl(args);

	switch (args[0]) {
		case 'unsetHot':
			unsetHot();
			break;
		case "exit_customer":
			if (hot) {
				WE().util.showConfirm(window, '', WE().consts.g_l.customer.view.save_changed_customer, ["processConfirmHot", "we_customer_save"], ["processConfirmHot", "unsetHot"
				].concat(args), WE().consts.g_l.button.save, WE().consts.g_l.button.revert);
				break;
			}
			top.opener.top.we_cmd("exit_modules");
			break;
		case "we_customer_new":
			if (hot) {
				WE().util.showConfirm(window, '', WE().consts.g_l.customer.view.save_changed_customer, ["processConfirmHot", "we_customer_save"], ["processConfirmHot", "unsetHot"
				].concat(args), WE().consts.g_l.button.save, WE().consts.g_l.button.revert);
				break;
			}
			if (top.content.editor.edbody.loaded) {
				top.content.editor.edbody.document.we_form.cmd.value = args[0];
				top.content.editor.edbody.document.we_form.cmdid.value = args[1];
				top.content.editor.edbody.submitForm();
			} else {
				window.setTimeout(we_cmd, 10, "we_customer_new");
			}
			break;
		case "we_customer_delete":
			if (top.content.editor.edbody.document.we_form.cmd.value === "home") {
				return;
			}
			if (!WE().util.hasPerm("DELETE_CUSTOMER")) {
				WE().util.showMessage(WE().consts.g_l.main.no_perms, WE().consts.message.WE_MESSAGE_WARNING, window);
				return;
			}
			if (!top.content.editor.edbody.loaded) {
				WE().util.showMessage(WE().consts.g_l.customer.view.nothing_to_delete, WE().consts.message.WE_MESSAGE_WARNING, window);
				break;
			}
			WE().util.showConfirm(window, "", WE().consts.g_l.customer.view.delete_alert, ["we_customer_delete_do"]);
			break;
		case "we_customer_delete_do":
			top.content.editor.edbody.document.we_form.cmd.value = "we_customer_delete";
			top.content.editor.edbody.submitForm();
			break;
		case "loadHeaderFooter":
			top.content.editor.edheader.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=edheader&text=" + encodeURI(args[1]);
			top.content.editor.edfooter.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=edfooter";
			break;
		case "loadHome":
			top.content.editor.edheader.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&home=1&pnt=edheader";
			top.content.editor.edbody.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&home=1&pnt=edbody";
			top.content.editor.edfooter.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&home=1&pnt=edfooter";
			break;
		case "we_customer_save":
			if (top.content.editor.edbody.document.we_form.cmd.value === "home") {
				return;
			}
			if (!WE().util.hasPerm("EDIT_CUSTOMER") && !WE().util.hasPerm("NEW_CUSTOMER")) {
				WE().util.showMessage(WE().consts.g_l.main.no_perms, WE().consts.message.WE_MESSAGE_WARNING, window);
				return;
			}

			if (top.content.editor.edbody.loaded) {
				top.content.editor.edbody.document.we_form.cmd.value = args[0];
				top.content.editor.edbody.submitForm();
			} else {
				WE().util.showMessage(WE().consts.g_l.customer.view.nothing_to_save, WE().consts.message.WE_MESSAGE_WARNING, window);
			}
			top.content.unsetHot();
			break;
		case "we_customer_edit":
			if (hot) {
				WE().util.showConfirm(window, '', WE().consts.g_l.customer.view.save_changed_customer, ["processConfirmHot", "we_customer_save"], ["processConfirmHot", "unsetHot"
				].concat(args), WE().consts.g_l.button.save, WE().consts.g_l.button.revert);
				break;
			}
			top.content.editor.edbody.document.we_form.cmd.value = args[0];
			top.content.editor.edbody.document.we_form.cmdid.value = args[1];
			top.content.editor.edbody.submitForm();
			break;
		case "show_admin":
			url = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=customer_admin";
			(new (WE().util.jsOverlay)(caller, 'top', url, "customer_admin", WE().consts.size.dialog.medium, WE().consts.size.dialog.small)).open();
			break;
		case "show_sort_admin":
			url = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=sort_admin";
			(new (WE().util.jsOverlay)(caller, 'top', url, "sort_admin", WE().consts.size.dialog.medium, WE().consts.size.dialog.small)).open();
			break;
		case "show_search":
			var keyword = top.content.we_form_treefooter.keyword.value;
			(new (WE().util.jsOverlay)(caller, 'top', WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=search&search=1&keyword=" + keyword, "search", WE().consts.size.dialog.small, WE().consts.size.dialog.small)).setResizeable().open();
			break;
		case "load":
			top.content.cmd.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=cmd&pid=" + args[1] + "&offset=" + args[2] + "&sort=" + args[3];
			break;
		case "we_users_selector":
			(new (WE().util.jsOverlay)(caller, 'top', url, "browse_users", WE().consts.size.dialog.small, WE().consts.size.dialog.smaller)).setResizeable().open();
			break;
		case "we_selector_image":
		case "we_selector_document":
			(new (WE().util.jsOverlay)(caller, 'top', url, "we_fileselector", WE().consts.size.dialog.big, WE().consts.size.dialog.medium)).setResizeable().open();
			break;
		case "show_customer_settings":
			(new (WE().util.jsOverlay)(caller, 'top',WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=settings", "customer_settings", WE().consts.size.dialog.small, WE().consts.size.dialog.tiny)).open();
			break;
		case "export_customer":
			(new (WE().util.jsOverlay)(caller, 'top',WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=export&art=2", "export_customer", WE().consts.size.dialog.small, WE().consts.size.dialog.small)).setResizeable().open();
			break;
		case "import_customer":
			(new (WE().util.jsOverlay)(caller, 'top',WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_showMod&mod=customer&pnt=import&art=1", "import_customer", WE().consts.size.dialog.small, WE().consts.size.dialog.small)).open();
			break;
		case "refreshForm":
			top.content.editor.edbody.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
			break;
		default:
			top.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
	}
}