/* global WE, top, we_cmd_modules,we_cmd */

/**
 * webEdition CMS
 *
 * $Author: Lukas Imhof $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';
we_cmd_modules.object = function (args, url, caller) {
	switch (args[0]) {
		/*case "object_edit"://does this make sense?!
		 case "edit_object":
		 new (WE().util.jsWindow)(caller, url, "edit_module", WE().consts.size.dialog.big, WE().consts.size.dialog.medium, true, true, true, true);
		 break;*/
		case "new_objectFile":
			we_cmd("new", WE().consts.tables.OBJECT_FILES_TABLE, "", WE().consts.contentTypes.OBJECT_FILE);
			break;
		case "new_objectfile_folder"://FIXME: where is the difference?
			we_cmd("new", WE().consts.tables.OBJECT_FILES_TABLE, "", WE().consts.contentTypes.FOLDER_OBJECTFILE);
			break;
		case "new_object":
			we_cmd("new", WE().consts.tables.OBJECT_TABLE, "", WE().consts.contentTypes.OBJECT);
			break;
			/* this is probably obsolete: looks like it never worked!
			 case "new_object_folder":
			 we_cmd("new", WE().consts.tables.OBJECT_TABLE, "", "folder");
			 break;
			 */
		case "we_object_class_changeLink":
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			top.load.location = url + '&we_transaction=' + args[1];
			break;

		case "we_object_class_fieldAddUser":
			// modified for use as selector callback: args[1] is reserved now for selector results
			args[4] = args[1].allIDs.join(',');
			args.splice(1, 1);
			url = WE().util.getWe_cmdArgsUrl(args);
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			WE().util.we_sbmtFrm(top.load, url);
			break;
		case "we_object_class_reloadEntry":
			// modified for use as selector callback: args[1] is reserved now for selector results
			if (args[1] && typeof args[1] !== 'string') {
				args.splice(1, 1);
			}
			url = WE().util.getWe_cmdArgsUrl(args);

			var entry, hidden, wholename;
			if (args[2] && (entry = caller.document.getElementById(args[2])) && (wholename = entry.getAttribute('data-wholename')) &&
				(hidden = caller.document.getElementById('hidden_' + wholename + '_0'))) {
				url += '&we_cmd[foldIndex]=' + hidden.name.substring(5, hidden.name.length - 1);
			}
			/* falls through */
		case "we_object_class_insertEntry":
		case "we_object_class_deleteEntry":
		case "we_object_class_entryUp":
		case "we_object_class_entryDown":
		case "we_object_class_multiobjectUp":
		case "we_object_class_multiobjectDown":
		case "we_object_class_multiobjectInsert":
		case "we_object_class_multiobjectDelete":
		case "we_object_class_selectUp":
		case "we_object_class_selectDown":
		case "we_object_class_selectInsert":
		case "we_object_class_selectDelete":
		case "we_object_class_changeEntry":
		case "we_object_class_fieldDelUser":
		case "we_object_class_ownersDeleteAll":
		case "we_object_class_removeImage":
		case "we_object_class_deleteLink":
		case "we_object_class_changeMultiobject":
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			WE().util.we_sbmtFrm(top.load, url);
			break;
		case 'object_changeTextareaParams_at_class':
			args[0] = 'we_object_class_reloadEntry';
			WE().util.dialogTop(caller).opener.parent.we_cmd.apply(window, Array.prototype.slice.call(args));
			break;
		case "we_object_class_textAreaEdit":
			(new (WE().util.jsOverlay)(caller, 'top', url, "edit_object_text", WE().consts.size.dialog.small, WE().consts.size.dialog.small)).open();
			break;
		case "we_object_file_linkChange":
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			top.load.location = url + '&we_transaction=' + args[1];
			break;

		case "we_object_file_reloadEntry":
			if (args[4] === 'setScrollTo') {
				this.setScrollTo();
			}
			/* falls through */
		case "we_object_file_objectlinkChange":
			// modified for use as selector callback: args[1] is reserved now for selector results
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			// splice args[1]
			args.splice(1, 1);
			url = WE().util.getWe_cmdArgsUrl(args);
			/* falls through */
		case "we_object_file_imageRemove":
		case "we_object_file_multiobjectUp":
		case "we_object_file_multiobjectDown":
		case "we_object_file_multiobjectInsert":
		case "we_object_file_multiobjectDelete":
		case "we_object_file_linkDelete":
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			url += "#f" + (parseInt(args[1]) - 1);
			WE().util.we_sbmtFrm(top.load, url);
			break;

		case "object_add_workspace":
		case "we_object_class_cssAdd":
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			if (typeof (args[1]) === "object") {
				url += "&we_cmd[1]=" + args[1].allIDs.join(",");
			}
			if (!WE().util.we_sbmtFrm(WE().layout.weEditorFrameController.getActiveDocumentReference().frames[1], url)) {
				url += "&we_transaction=" + args[2];
				window.we_repl(WE().layout.weEditorFrameController.getActiveDocumentReference().frames[1], url);
			}
			break;

		case "object_del_workspace":
		case "we_object_class_cssDel":
		case "object_changeTempl_ob":
		case "we_object_class_getClassWs":
			if (!WE().util.we_sbmtFrm(WE().layout.weEditorFrameController.getActiveDocumentReference().frames[1], url)) {
				url += "&we_transaction=" + args[2];
				window.we_repl(WE().layout.weEditorFrameController.getActiveDocumentReference().frames[1], url);
			}
			break;
		case "object_obj_search":
			window.we_repl(window.load, url);
			break;
		case 'fieldHref_selectIntHref_callback':
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			if (parseInt(args[2])) {
				this.document.we_form.elements[args[3]][0].checked = true;
			}
			break;
		case 'fieldHref_selectExtHref_callback':
			WE().layout.weEditorFrameController.getActiveEditorFrame().setEditorIsHot(true);
			if (args[2] === 'showRadio') {
				this.document.we_form.elements[args[3]][1].checked = true;
			}
			break;
		case 'fieldMultiobject_selectMultiobject_callback':
			if (parseInt(args[1].currentID) === this.doc.docId) {
				WE().util.showMessage(WE().consts.g_l.object.multiobject_recursion, WE().consts.message.WE_MESSAGE_ERROR, window);
				this.document.we_form.elements[args[1].JSIDName].value = '';
				this.document.we_form.elements[args[1].JSTextName].value = '';
			}
			if (args[2] === 'isSEEM') {
				we_cmd('we_object_file_objectlinkChange', '', this.doc.we_transaction, args[3]);
			}
			break;
		case "we_object_file_preview":
			/* OLD jsWindow */ new (WE().util.jsWindow)(caller, url, "preview_object", WE().consts.size.dialog.fullScreen, WE().consts.size.dialog.fullScreen, true, true);
			break;
		case "we_object_class_createTemplate":
			(new (WE().util.jsOverlay)(caller, 'self',url, "tmpfromClass", WE().consts.size.dialog.small, WE().consts.size.dialog.smaller)).setResizeable().open();
			break;
		case "open_object":
			/* command was used in menu -> files -> open -> class: deactivated since 8.0*/
			we_cmd("load", WE().consts.tables.OBJECT_TABLE);
			url = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_selector_document&we_cmd[filter]=object&we_cmd[table]=" + WE().consts.tables.OBJECT_TABLE + "&we_cmd[jsCmd]=doClickWithParameters&we_cmd[open_doc]=1";
			(new (WE().util.jsOverlay)(caller, 'top',url, "we_dirChooser", WE().consts.size.dialog.big, WE().consts.size.dialog.medium)).setResizeable().open();
			break;
		case "open_objectFile":
			/* command was used in menu -> files -> open -> object: deactivated since 8.0*/
			we_cmd("load", WE().consts.tables.OBJECT_FILES_TABLE);
			url = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_selector_document&we_cmd[filter]=objectFile&we_cmd[table]=" + WE().consts.tables.OBJECT_FILES_TABLE + "&we_cmd[jsCmd]=doClickWithParameters&we_cmd[open_doc]=1";
			(new (WE().util.jsOverlay)(caller, 'top',url, "we_dirChooser", WE().consts.size.dialog.big, WE().consts.size.dialog.medium)).setResizeable().open();
			break;
		default:
			return false;
	}
	return true;
};