/* global tinymce */

/**
 * webEdition CMS
 *
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

(function () {
	var weimage = (function () {

		var global = tinymce.util.Tools.resolve('tinymce.PluginManager');
		var open = function (ed, dropID) {
			if (ed.dom.getAttrib(ed.selection.getNode(), 'class', '').indexOf('mceItem') !== -1) { // ???
				return;
			}

			var
				initialSrc = '',
				initialLongdescSrc = '';
			if (!dropID) {
				dropID = 0;
				if (ed.selection.getNode().nodeName === 'IMG' && ed.dom.getAttrib(ed.selection.getNode(), 'src', '')) {
					initialSrc = ed.dom.getAttrib(ed.selection.getNode(), 'src', '');
					initialLongdescSrc = ed.dom.getAttrib(ed.selection.getNode(), 'longdesc', '');
				}
			}

			ed.windowManager.openWePlugin({
				file: '/webEdition/we_cmd_frontend.php?we_cmd[0]=open_dialog_image&we_cmd[task]=openDialog&we_dialog_args[initialSrc]=' + encodeURIComponent(initialSrc) + '&we_dialog_args[initialID]=' + dropID + '&we_dialog_args[isFrontend]=' + ed.getParam('weIsFrontend') + '&we_dialog_args[imageStartID]=' + ed.getParam('weImageStartID') + '&we_dialog_args[initialLongdescSrc]=' + encodeURIComponent(initialLongdescSrc),
				popup_css: false,
				width: 600,
				height: 610
			}, {
				plugin_url: ''
			});
		},
			Dialog = {open: open},
			Commands = {register: function (editor) {
					editor.addCommand('mceWeimage', function (unknown, dropID) {
						Dialog.open(editor, dropID);
					});
				}},
			Buttons = {register: function (editor) {
					editor.ui.registry.addToggleButton('weimage', {
						icon: 'image',
						tooltip: WE().consts.g_l.tinyMceTranslationObject.tt_weimage,
						onAction: function () {
							editor.execCommand('mceWeimage');
						},
						onSetup: function (buttonApi) {
							editor.weControlManager.register('button', 'weimage', buttonApi);
						}
					});

					editor.ui.registry.addMenuItem('weimage', {
						icon: 'image',
						text: 'Image',
						onAction: function () {
							editor.execCommand('mceWeimage');
						}
					});
					/*
					 editor.ui.registry.addContextMenu('weimage', {
					 update: function (element) {
					 return !element.src ? '' : 'weimage';
					 }
					 });
					 */

				}};

		global.add('weimage', function (editor) {
			Commands.register(editor);
			Buttons.register(editor);
			return {};
		});



		function Plugin() {}

		return Plugin;

	}());
})();